FSUIPC7 v7.5.6 released on 31st January 2026 contains the following changes:
  – ON ANY RUNWAY simvar has been added to offset 0x0272 as a 1-byte Boolean (read-only)
  – AMBIENT IN CLOUD simvar has been added to offset 0x0273 as a 1-byte Boolean (read-only)
  - correction to saving state of Open On Start option
  - change MF preset name if already exists by prefixing with vendor & aircraft
  - improvements to starting and stopping PMDG-specific threads (used to populate PMDG-specific offsets)
  - for MSFS2024, to determine the airfolder, use the folder directly after SimObjects\Airplanes and not the folder containing the aircraft.cfg file
  - developer camera state (18) flagged as an in-flight camera state (also in WASM)
  - if ini option init3308 is being used, offset 0x3308 will no longer be updated to the correct value once FSUIPC7 is connected to MSFS
  - WASM and WAPI both updated to version 1.1.0 - changesare:
     - WAPI: allow for sleep/pauses when executing calculator code by adding ' SLEEP::n ' (where n is the number of milliseconds)
	         into the calculator code string (this will pause the WAPI thread)
	 - WASM: allow for sleep/pauses when executing calculator code by adding ' SLEEP:n ' (where n is the number of milliseconds)
	         into the calculator code string (this will pause the WASM thread)
			 Camera state 18 (developer camera) flagged as an in-flight camera state
		     Only scan for new lvars rather than performing a complete scan for all lvars each time*
  - AutoSave menu option only now enabled once FSUIPC7 is connected to MSFS. 
  
* This drastically reduces the chance of a WASM CTD which has been an ongoing issue for several years now.
  With this change, the WASM should rarely CTD, although this is still possible.
  Asobo have acknowledged that the WASM CTD issue (when calling the gauge API function get_name_of_named_variable)
  is on their side, and they will work on a fix for MSFS2024 and see if it can be backported to MSFS2020.

FSUIPC7 v7.5.5 released on 8th November 2025 contains the following changes:
  - allow repeated LuaValue calls with the same parameter: previously a 2nd or subsequent
    call to LuaValue (on the same script) with the same parameter/ipcPARAM value would have no affect
  - disable button actions until ready, i.e. SimConnect fully initialised and all threads started (when ready-to-fly)
  - corrected bug that confused text in multiple Wnd windows
  - added message to main window to show current profile in use
  - non-functional technical changes/improvements
  - allow successive (masked) axis events with the same parameter to be sent.
    Previously, successive (masked) axis events with the same parameter were blocked.
  - ensure WideServer is stopped before FSUIPC exits (to allow shutdown commands to be sent to WideClients)
  - Correction to assignments on virtual buttons to Input Events that would result in a
    failure and an '**** Cannot execute empty Input Event' message even though the Input Event is known.
  - New (Key) events/controls added for both MSFS2020 and MSFS2024:
		AP_PANEL_MACH_HOLD_TOGGLE
		COM_2_SPACING_MODE_SWITCH
		COM_3_SPACING_MODE_SWITCH
  - New (key) events/controls added for MSFS2024 (only):
		AIRSHIP_VALVE_1_CLOSE
		AIRSHIP_VALVE_1_OPEN
		AIRSHIP_VALVE_1_SET
		AIRSHIP_VALVE_1_TOGGLE
		AIRSHIP_VALVE_2_CLOSE
		AIRSHIP_VALVE_2_OPEN
		AIRSHIP_VALVE_2_SET
		AIRSHIP_VALVE_2_TOGGLE
		AIRSHIP_VALVE_3_CLOSE
		AIRSHIP_VALVE_3_OPEN
		AIRSHIP_VALVE_3_SET
		AIRSHIP_VALVE_3_TOGGLE
		AIRSHIP_VALVE_4_CLOSE
		AIRSHIP_VALVE_4_OPEN
		AIRSHIP_VALVE_4_SET
		AIRSHIP_VALVE_4_TOGGLE
		AIRSHIP_VALVE_CLOSE
		AIRSHIP_VALVE_OPEN
		AIRSHIP_VALVE_SET
		AIRSHIP_VALVE_TOGGLE
		AXIS_BURNER_PITCH_SET
		AXIS_BURNER_ROLL_SET
		AXIS_THRUST_VECTOR_HORIZONTAL_SET
		AXIS_THRUST_VECTOR_VERTICAL_SET
		BALLOON_VENT_CLOSE
		BALLOON_VENT_OPEN
		BALLOON_VENT_SET
		BALLOON_VENT_TOGGLE
		BURNER_PITCH_DEC
		BURNER_PITCH_INC
		BURNER_ROLL_DEC
		BURNER_ROLL_INC
		BURNER_VALVE_CLOSE
		BURNER_VALVE_OPEN
		BURNER_VALVE_SET
		BURNER_VALVE_TOGGLE
		ELECTRICAL_LINE_BREAKER_SET
		ELECTRICAL_LINE_BREAKER_TOGGLE
		ELECTRICAL_LINE_CONNECTION_SET
		ELECTRICAL_LINE_CONNECTION_TOGGLE
		HYDRAULIC_SWITCH_TOGGLE
		HYDRAULIC_VALVE_CLOSE
		HYDRAULIC_VALVE_OPEN
		HYDRAULIC_VALVE_SET
		HYDRAULIC_VALVE_TOGGLE
		LIGHT_AMBIENT_COLOR_SET
		LIQUID_DROPPING_SYSTEM_DOOR_CLOSE
		LIQUID_DROPPING_SYSTEM_DOOR_COMMAND_GROUP_CLOSE
		LIQUID_DROPPING_SYSTEM_DOOR_COMMAND_GROUP_OPEN
		LIQUID_DROPPING_SYSTEM_DOOR_COMMAND_GROUP_SET
		LIQUID_DROPPING_SYSTEM_DOOR_COMMAND_GROUP_TOGGLE
		LIQUID_DROPPING_SYSTEM_DOOR_OPEN
		LIQUID_DROPPING_SYSTEM_DOOR_SET 
		LIQUID_DROPPING_SYSTEM_DOOR_TOGGLE
		LIQUID_DROPPING_SYSTEM_SCOOP_CLOSE
		LIQUID_DROPPING_SYSTEM_SCOOP_OPEN
		LIQUID_DROPPING_SYSTEM_SCOOP_SET
		LIQUID_DROPPING_SYSTEM_SCOOP_TOGGLE
		PNEUMATICS_AREA_TEMPERATURE_DEC
		PNEUMATICS_AREA_TEMPERATURE_INC
		PNEUMATICS_AREA_TEMPERATURE_SET
		PNEUMATICS_FAN_SET
		PNEUMATICS_JUNCTION_LINE_OPENING_STATUS_SET
		PNEUMATICS_PACK_FLOW_AUTO_OFF
		PNEUMATICS_PACK_FLOW_AUTO_ON
		PNEUMATICS_PACK_FLOW_AUTO_SET
		PNEUMATICS_PACK_FLOW_MODE_HIGH
		PNEUMATICS_PACK_FLOW_MODE_LOW
		PNEUMATICS_PACK_FLOW_MODE_NORM
		PNEUMATICS_PACK_FLOW_MODE_SET
		PNEUMATICS_PACK_OFF
		PNEUMATICS_PACK_ON
		PNEUMATICS_PACK_SET
		PNEUMATICS_PACK_TOGGLE
		PNEUMATICS_PACKS_FLOW_DEC
		PNEUMATICS_PACKS_FLOW_INC
		PNEUMATICS_PACKS_FLOW_SET
		PNEUMATICS_TARGET_CABIN_ALTITUDE_DEC
		PNEUMATICS_TARGET_CABIN_ALTITUDE_INC
		PNEUMATICS_TARGET_CABIN_ALTITUDE_SET
		PNEUMATICS_VALVE_CLOSE
		PNEUMATICS_VALVE_MODE_AUTO
		PNEUMATICS_VALVE_MODE_CLOSED
		PNEUMATICS_VALVE_MODE_OPEN
		PNEUMATICS_VALVE_MODE_SET
		PNEUMATICS_VALVE_OPEN
		PNEUMATICS_VALVE_SET
		PNEUMATICS_VALVE_TOGGLE
		SKYDIVE_DOORLIGHTS_DEC
		SKYDIVE_DOORLIGHTS_GETREADY
		SKYDIVE_DOORLIGHTS_INC
		SKYDIVE_DOORLIGHTS_JUMP
		SKYDIVE_DOORLIGHTS_OFF
		SPRAY_OFF
		SPRAY_ON
		SPRAY_TOGGLE
		SPRAY_SET 
  - menu items to list lvars and hvars moved to Log menu (from Add-ons->WASM menu)
  - minor updates to logging Input Events, which are now also logged to the FSUIPC7.log file
  - added two new lua functipns ipc.getInstallationFolder() and ipc.getLuaPath()
  - added simvar INTERACTIVE POINT GOAL to offset 0x341B as a bitwise byte for both reading and writing
  - added simvar INTERACTIVE POINT OPEN to offset 0x3424 as a bitwise byte for both reading and writing
  - allow reverse thrust controls for separate engines 1/2/3/4
  - new ini parameter IgnoreAltGrande which, when set, will remove the lctrl event when ralt is pressed/released
FSUIPC7 v7.5.4 released on 13th July 2025 contains the following changes:
  - installer now backs-up ini files when a new version is installed.
    Note that ini files will not be backed-up when re-installing the same version.
  - non-functional technical changes/improvements
  - correction to lua ipc.execInputEvent function to allow for floating point/decimal parameters
  - correction to detect the enter/return key when running MSFS2020
  - added additional check for detecting PMDG aircraft (to start additional threads to populate the
    PMDG-specific offsets) using the air folder name, as string 'pmdg' is not present in the title
	when using MSFS2024.
FSUIPC7 v7.5.3 released on 1st April 2025 contains the following changes:
  - allow helicopter-specific axes to be suppressed/disconnected via offset 0x310A
  - allow lua ipc.control function to take two parameters for the control
  - delay auto-start of WebSocketServer until offset 0x3308 populated (i.e. once connected to MSFS)
  - allow use of Input Events in macros
  - additional check on opening aircraft.cfg file added before being parsed
  - recompiled using latest MSFS SDK 0.24.4
  - added new lua functions to control/access lvars via the lvar id rather than the name.
    These should be preferred over their name counterparts for efficiency reasons.
  - Lvar access via name now case-insensitive

FSUIPC7 v7.5.2 released on 14th February 2025 contains the following changes:
  - Livery name added to offset 0x2480 (128 bytes). Only available in MSFS2024
  - Moved full 6 character ident of 6 nearest airports from offset 0x0640 to 0x0630:
       sorry about this - there was not enough space when starting at offset 0x0640.
  - corrected the FS control used when writing to offset 0x0284 (ADF1 Standby Frequency)
  - Lua function ipc.getLvarId("name") corrected to return nil when the lvar doesn't exist
  - simvar PLANE TOUCHDOWN NORMAL VELOCITY added to offset 0x0654
  - Allow the ELEVATOR_TRIM_SET event to be calibrated
  - improved mechanism to add input events to offsets
  - Changed to not load the general InputEventOffsets section if a profile-specific section is available
    (previously both sections were loaded)
  - Added new input strings (for keyboard input) for MSFS2024 and allow for different
    strings in MSFS202 and MSFS2024
  - Added functionality to auto download and install when a new version is available

FSUIPC7 v7.5.1 released on 20th December 2024 contains the following changes:
  - added new control 'Rescan connected Controllers' [1157]
  - Added new ini parameter Init3308 which can be used to set a value in
    offset 0x3308 (FS version number) for add-ons that are expecting a value
	in this offset at start-up.
  - Allow offset 0x3308 to be manually updated. This is needed by some FSUIPC add-ons
    that have not yet been updated to recognise the value 14 in this offset (for MSFS2024).
	If an add-on fails as it does not recognose MSFS2024, you can set the value of
	this offset to 13 (best done in an ipcInit.lua script) to fool the add-on
	that it is MSFS2020 being used.

FSUIPC7 v7.5.0 released on 6th December 2024 contains the following changes:
  - Installer updated to detect and install FSUIPC7 into MSFS2024
  - FSUIPC WASM module updated for MSFS2024 - new version is 1.0.7
  - Allow negative and 0 values for InitialStallTime ini parameter
    Using such values will disable the timeout on the initial simconnect open call, and may
	help on some overloaded systems where the initial connection is taking a long time to complete
  - added ability to adjust event priority levels. This can help some add-ons work correctly,
    and make more events visible to FSUIPC7 for logging purposes
  - automatic adjustment of priority levels for FSLabs A321 aircraft
  - FS Events table reduced (null events removed) and the following new events
    have been added:
	    CAPTURE_SCREENSHOT
		DECREASE_DECISION_ALTITUDE_MSL
		INCREASE_DECISION_ALTITUDE_MSL
        LETTERBOX
		MOUSE_LOOK_TOGGLE
		MP_PAUSE_SESSION
		VIEW_TYPE
  - forced uniqueness of preset names. Presets with duplicate names will no longer be loaded
  - basic checks on preset calc. code and don't load if invalid
  - Removed EventsViaCommands ini parameter, as this is not applicable to MSFS2020 or MSFS2024
  - corrections to pause state for MSFS2024
  - update offsets holding Input Events directly when writing to them
  - logging of received Input Events corrected. Previously received Input Events weren't logged unless
    the DontLogTheseIE ini parameter was set
  - For MSFS 2024, write the value 14 to offset 0x3308, and the value 120 to offset 0x3124
  - folders used for saved flights and plans updated to use MSFS2024 folders (when using this version)
  - separate AutoSave sections now used for MSFS2020 and MSFS2024
  - PMDG threads now stopped on aircraft change (previously used camera state)

FSUIPC7 v7.4.18 released on 1st November 2024 contains the following changes:
  - traffic zapper functionality added (to remove AI traffic)
  - traffic panel added with access to traffic limiter options
  - removed automatic change of AI aircraft state (from engine start or sleeping to enroute) when aircraft altitude
    differs from ground altitude by 100 feet or more. Previous behavior can be re-instated by adding:
	   AIAboveGroundLimit=100
	to the [General] section of your FSUIPC7.ini file (although this is NOT recommended)
	Note this change was made as it looks like the ground altitude for some sleeping AI traffic was changing
	to 0, causing them to switch from ground-to-airborne
  - added facility to log lvar updates/changes via the FSUIPC7.ini file
  - WASM version updated to 1.0.6:
             - default ini paramters updated to reduce number of lvar scans
			 - prevent lvar scanning restarting after LvatScanPeriod past
			 - minor logging updates

FSUIPC7 v7.4.17 released on 4th September 2024 contains the following changes:
  - delayed request for key input (from MSFS) to prevent issues with key reception
  - corrections for when running FSUIPC7 in a client PC:
      - enable WAPI even though WASM is not installed (on client PC)
	  - start/stop PMDG 777 data thread when needed
  - mapped AI traffic state STATE_SIMPLE_FLIGHT

FSUIPC7 v7.4.16 released on 25th July 2024 contains the following changes:
  - WASM updated to 1.0.5. Changes include:
        - performance improvements: switched to using tagged data
		- LvarScanPeriod ini parameter now accepts negative values
		- functional improvements for when lvar update period is disabled in WASM
		- log message updates
  - length allowed for preset node names increased (in Find Preset window) so that duplicate node names not shown
  - mapped AI traffic state STATE_SIMPLE_TAKEOFF to STATE_TAKEOFF
  - log message changes to prevent buffer overrun

FSUIPC7 v7.4.15 released on 12th July 2024 contains the following changes:
  - corrected memory issue in WASM
  - start of FSUIPC threads and WASM/WAPI connection changed to use camera state
  - removed option to stop WAPI when MSFS in main menu - WAPI connection now maintained unless forcibly stopped
  - correction to starting/stopping PMDG theads for 737 and 777 on aircraft change

FSUIPC7 v7.4.14 released on 5th July 2024 contains the following changes:
  - WASM updated to version 1.0.4: bug fixed that could crash WASM in certain situations
  - Specific offsets for PMDG 777 enabled
  - Reset status of auto-save toggle once a flight is finished
  - clear Input Event checkbox in button assignments when button not assigned
  - Added new menu option to reload presets: File -> Reload Presets

FSUIPC7 v7.4.13 released on 5th June 2024 contains the following changes:
  - recompiled agains latest SDK (0.24.3.0)
  - corrected bug where devices with a vendor id of 0000 were ignored
  - Added FUEL TANK SELECTOR:2 simvar to offset 0x0B22
  - minimum initial stall time increased from 5 to 15 seconds
  - log message updates
  - WASM update: new ini parameter LvarScanPeriod added, default to 10 (minutes).
    This is the period, starting from when aircraft loaded, that the WASM will scan for lvars
	and push them out to clients. After this period has elapsed, new lvars will only be seen by FSUIPC7
	if created by FSUIPC7 or if/when a rescan is performed.
  - default auto-start method switched back to using EXE.xml file

FSUIPC7 v7.4.12 released on 23rd May 2024 contains the following changes:
  - Functionality to auto-tune the start-up parameters of FSUIPC7 added. See Advanced
    User Guide for details.
  - Default auto-start method of FSUIPC7 changed to use the MSFS.bat file. The ability
    to start FSUIPC7 via the MSFS.exe is still available as an option in the installer.
  - New ini parameter added: IgnoreDevice. This parameter goes in the [JoyNames]
    section of the FSUIPC7.ini and can be used to ignore a specific device (or all
	devices from a specific Vendor) during the HiD scanning for your devices.
  - Added new ini parameter MaxCustomControlNumber to allow the range of custom
    control numbers available to be user-specified.
  - delay start of ipcInit.lua until data requested
  - Added icao_airline (from aircraft.cfg file) at offset 0x062C
  - Added BRAKE PARKING INDICATOR simvar at offset 0x028D
  - new lua function ipc.getInputEventValue
  - functionality to add Input Events to offsets via new ini file section [InputEventOffsets].	
  - Update to MSFS SDK 0.24.2.0. The following new simulator events/controls
    have been added:
		HELICOPTER_ENGINE_1_GOVERNOR_SWITCH_OFF
		HELICOPTER_ENGINE_1_GOVERNOR_SWITCH_ON
		HELICOPTER_ENGINE_1_GOVERNOR_SWITCH_TOGGLE
		HELICOPTER_ENGINE_1_GOVERNOR_SWITCH_SET
		HELICOPTER_ENGINE_1_BEEP_TRIM_INCREASE
		HELICOPTER_ENGINE_1_BEEP_TRIM_DECREASE
		HELICOPTER_ENGINE_1_BEEP_TRIM_SET
		HELICOPTER_ENGINE_2_GOVERNOR_SWITCH_OFF
		HELICOPTER_ENGINE_2_GOVERNOR_SWITCH_ON
		HELICOPTER_ENGINE_2_GOVERNOR_SWITCH_TOGGLE
		HELICOPTER_ENGINE_2_GOVERNOR_SWITCH_SET
		HELICOPTER_ENGINE_2_BEEP_TRIM_INCREASE
		HELICOPTER_ENGINE_2_BEEP_TRIM_DECREASE
		HELICOPTER_ENGINE_2_BEEP_TRIM_SET
  - added log message to log privilege status of FSUIPC process, elevated (i.e. admin) or standard 

FSUIPC7 v7.4.11 released on 31st March 2024 contains the following changes:
  - default InitialStallTime set to 15 seconds (was 5)

FSUIPC7 v7.4.10 released on 28th March 2024 contains the following changes:
  - fixed issue that prevented Input Event assignments to entering/leaving axis
    ranges from working
  - fixed an issue that could prevent key presses/releases (including hot keys) being received
    and processed

FSUIPC7 v7.4.9 released on 17th March 2024 contains the following changes:
  - delay added between sim detection and connection
  - correction to start PMDG threads for PMDG offset population

FSUIPC7 v7.4.8 released on 2nd March 2024 contains the following changes:
  - various checks added to prevent memory issues
  - various timers modified to allow things to start quicker
  - update to ignore 2nd set of Input Events received from some aircraft which
    was causing a corruption issue (could result in a buttons or keys section being removed!)  

FSUIPC7 v7.4.7 released on 28th February 2024 contains the following changes:
  - correctly store/save a key release preset name (the key press name was being saved)
  - prevent Input Events being requested twice in some situations
  - corrections to auto-starting luas when not using the WAPI
  - corrections to auto-starting luas when the air file folder is used for profiles
  - WAPI connection delayed by 7.5s after starting a flight from World Map
  - Input Events loaded in unregistered version, for use via offsets
  - switched to check for Steam User.cfg file before MS Store User.cfg file (to match installer)
  - StartEarly parameter added for [WodeServer], to start WideServer once a simconnect connection is obtained 

FSUIPC7 v7.4.6 released on 14th February 2024 contains the following changes:
  - EXT Wnd size/position not saved if iconized (to prevent a CTD when re-starting)
  - initial stall time set to a minimum of 45seconds when auto-started
  - fixed issue with preset name not being saved correctly for key assignments when using the Find Preset dialog box
  - varios changes to start-up initialisation
  - added Never option to OpenOnStart ini parameter

FSUIPC7 v7.4.5 released on 2nd February 2024 contains the following changes:
  - corrected use of Hot Keys when using the free/unregistered version of FSUIPC7
    An issue was introduced that prevented Hot Key processing in 7.4.3 - sorry about this!
  - allow comments in [Auto] section
  - additional checks added on simconnect open to ensure everything received ok, otherwise
    close connection and reconnect. Initial stall time also reduced from 120 to 30 seconds

FSUIPC7 v7.4.4 released on 21st January 2024 contains the following changes:
  - corrected simconnect issue introduced in previous version

FSUIPC7 v7.4.3 released on 19th January 2024 contains the following changes:
  - bug fixed that prevented parameters to key assignments being saved when assigning to lua controls for lua files with an index >= 32
  - various log message changes
  - technical changes in detecting when to start various threads and when to kill auto-luas after
    going back to the MSFS main menu system

FSUIPC7 v7.4.2 released on 2nd January 2024 contains the following changes:
  - bug fixed that prevented parameters to button assignments being saved when assigning to lua controls for lua files with an index >= 32

FSUIPC7 v7.4.1 released on 15th December 2023 contains the following changes:
  - open FSUIPC main window on start-up if new version available
  - fixed bug in key assignments that added an release control when non specified
  - allow the following helicopter axes to be calibrated using FSUIPC's calibration facilities:
		AXIS_CYCLIC_LATERAL_SET -> calibrate as Aileron
		AXIS_CYCLIC_LONGITUDINAL_SET  -> calibrate as Elevator
		AXIS_COLLECTIVE_SET -> calibrate as Prop-pitch
		AXIS_HELICOPTER_THROTTLE_SET -> calibrate as Throttle
		HELICOPTER_THROTTLE_SET -> calibrate as Throttle
		AXIS_HELICOPTER_THROTTLE1_SET -> calibrate as Throttle1
		HELICOPTER_THROTTLE1_SET -> calibrate as Throttle1
		AXIS_HELICOPTER_THROTTLE2_SET -> calibrate as Throttle2
		HELICOPTER_THROTTLE2_SET -> calibrate as Throttle2

FSUIPC7 v7.4.0 released on 8th December 2023 contains the following changes:
  - updated to SDK 0.23.1.0
  - corrected use of DELAY and READY parameters in [Programs] ini file section
  - new option/parameter in [Programs] section: CONNECTED. When specified, this will delay the start of
    a program until FSUIPC7 is connected to MSFS and initial data to populate the offsets has been received.
  - WAPI updated to 1.0.4: locking improved/corrected to prevent issue when new
    config data received before previous one fully processed
  - WASM updated to 1.0.3: minor bug fix, no functional change
  - new ini parameter ObeyThrottleLowerLimit added. This prevents the throttle from
    going below its lower limit when Throttle Decr controls are used to activate reversers.
  - the Log->New Log menu option has been disabled. This can be enabled by using the new ini parameter EnableNewLog
  - allow assignments to Input Events, for buttons, keys and on entering/leaving axis ranges (but not for axis assignments)
  - new lua function ipc.execInputEvent added
  - new ini parameter DontLogTheseIE. This is the same as the DontLogThese ini parameter but
    works on Input Events.
  - new Log menu items added for Input Events:
      Log->Input Events: to log input events when received
	  Log->List Input Events: to list available input events in the FSUIPC7 main window
  - offset 0x7C50 has also been updated to allow Input Events to be sent.
    BREAKING CHANGE: the parameter (for setting an lvar value, parameter for a preset or parameter
	for an Input Event) has been moved from offset 0x7C80 to 0x7C90 as using 0x7C80 does not allow
	enough space for the full lvar or preset name (up to 64 bytes) at offset 0x7C50.					 
  - full nearest airport Ident (6 characters each) list added to offset 0x0640. This is to compliment the
    nearest 6 airport list at offset 0x0658 that only holds space for the 4 characters of the Ident (ICAO).

FSUIPC7 v7.3.25 released on 29th October 2023 contains the following changes:
  - WAPI updated to 1.0.3: thread protection added for when sending calculator code
  - minor correction to simconnect re-connection logic to fix bug that prevented FSUIPC7 from shutting down in certain situations
  - fixed issue that prevented setting font and font attributes in lua Wnd library functions
  - removed re-writing of Delay ini parameter in [Programs] section
  - update to pause indication offset 0x0264 and pause control offset 0x0262

FSUIPC7 v7.3.24 released on 2nd October 2023 contains the following changes:
  - Added CAMERA SUBSTATE at offset 0x026E, CAMERA VIEW TYPE AND INDEX at offsets
    0x026F (index 0) and 0x0270 (index 1), GAMEPLAY CAMERA FOCUS at offset 0x0271,
	all read/write.
  - Changed offset 0x026D (CAMERA STATE) to read/write (was read-only).
  - minor update to version check messages
  - updated to MSFS SDK 0.22.3.0. The following new events/controls have been added:
		3rd Party Window Open Primary
		3rd Party Window Open Secondary
		3rd Party Window Move Down
		3rd Party Window Move Up
		3rd Party Window Validate
  - Re-enabled write to offsets 0x0284, 0x0286, 0x0288 & 0x028A (ADF1/2 stby freq)

FSUIPC7 v7.3.23 released on 15th September 2023 contains the following changes:
  - added 'Find Preset' button to key and button assignments dialog, which shows
    a tree-view for selection of a preset
  - the preset menu for axis asignments (left-hand side to axis, not right-hand side
    to axis range) has been restricted to contain only those presets that accept a parameter
  - added version check on start-up: a message will be shown if a newer version is available

FSUIPC7 v7.3.22 released on 4th September 2023 contains the following changes:
  - re-enabled offset 0x341E (Hydraulic Switch)
  - improved logic in simconnect re-connection
  - Added 'Send Preset to FS' as distinct axis assignment option
  - Load presets even when WASM is not installed. This is to prevent assignments to presets being lost when the WASM module is temporarily removed/disabled
  - Added ini parameter ExitIfEventsAreMissing, with a deault value if FALSE. When set, this prevents assignments to presets being lost if the events.txt file is temporarily unavailable.

FSUIPC7 v7.3.21 released on 9th June 2023 contains the following changes:
  - added ShowSplash ini parameter, to allow FSUIPC7 splash screen to be disabled
  - added LogLuaNew ini parameter, used to overwrite the lua log file when lua logged to a separate file
  - added handling for events using the new _EX1 event handling system
  - added Log->WAPI menu to allow WAPI log level to be set

FSUIPC7 v7.3.20 released on 24th April 2023 contains the following changes:
  - allow key presses/releases sent to the FS to be received back for further action, e.g. to support hot-key assignments
  - added back use of ini parameter ShortAircraftNameOk to allow profile substring matching to be turned off, specifically
    for use when using UseAirLocForProfiles ini parameter
  - added support for '@' character as a parameter placeholder in preset calculator code (as used by MobiFlight)
  - added lua function ipc.execPreset to execute a calculator code preset by name (preset parameter also supported)
  - additional WHYSTART logging added

FSUIPC7 v7.3.19 released on 22nd March 2023 contains the following changes:
  - updated to MSFS SDK 0.21.0.0
  - new control/event added: Elect Fuel Pump Set
  - various none-functional updates (code cleaning)

FSUIPC7 v7.3.18 released on 15th March 2023 contains the following changes:
  - new ini parameter added: ComWriteLoopTime. Default value 10ms
  - default value of ComReadLoopTime changed from 20ms to 10ms
  - WASM updated to 1.0.2:
        - LvarScanFrequency ini parameter changed to determine max number of scans per second regardless of
		  LvarUpdateFrequency setting. Positive values indicate maximum number of scans per second, negative values
		  indicate minimum number of seconds between scans. A value of 0 turns off scanning for new lvars.
		  The default value for this setting is -2 (i.e. scan for new lvars approximately every 2 seconds)
	    - lvar values not updated until at least 250ms after config change (to give time for clients to process changes)
	    - minor memory related bug-fixes and logging updates
  - WAPI updated to 1.0.2:
	    - lvars-ready callback now called once initial values received
		- lvar-value reading locked to prevent reading until initial values received
		- minor updates in logging and to prevent compilation warnings
  - The following simvars are no longer requested:
			0x08F8: FUELSYSTEM ENGINE PRESSURE:1
            0x0990: FUELSYSTEM ENGINE PRESSURE:2
            0x0A28: FUELSYSTEM ENGINE PRESSURE:3
            0x0AC0: FUELSYSTEM ENGINE PRESSURE:4
	This is a temporary measure to prevent excessive log messages in the MSFS console window when using aircraft
	that do not use the new Fuel System. I will look into a proper fix to only request these simvars when used in
	a future update.
  - The default value for the NumberOfPumps ini paramater set to 0. As with the previous item, this is to prevent
    log message flooding in the Asobo console window when using aircraft that do not use the new Fuel System.

FSUIPC7 v7.3.17 released on 25th February 2023 contains the following changes:
  - recognise profile-specific button presses in button assignment window even if profile-specific checkbox not checked
  - WAPI and WASM updated to version 1.0.0, containing the following changes:
      - up to 10,220 lvars now loaded
	  - automatic rescanning for new lvars: no longer necessary to reload to pick-up new lvars
	  - lvars-available callback delayed by 1s after names available so that the initial values can be received.
	    This means that the initial value will be available in this callback, and no lvar-callback will be received
		until the lvar value changes [for developers using the WAPI only]

FSUIPC7 v7.3.16 released on 11th January 2023 contains the following changes:
  - added axis control/event Rotor Axis Tail Rotor Set
  - Input keys strings updated to the latest MSFS SDK: mainly changes to numpad keys when numlock is off, and some new additional keys added
  - correction to key repeat handling whuch caused repeated key down events being sent in certain situations
  - added log message to indicate custom control numbers registered
  - PMDG 737 header and offsets updated to version 3.0.56. Note that the offsets for the following variables have changed:
         AircraftModel - was 6C8D, now 6C8E
		 WeightInKg - was 6C8E, now 6C90
		 GPWS_V1CallEnabled - was 6C8F, now 6C91
		 GroundConnAvailable - was 6C90, now 6C92
	Last byte of first reserved area for PMDG737 is now 6C93 (was 6C91)
  - new ini parameter MaxButtonAssignments that allows you to increase the default number of available button assignments (2099)
  - offsets that hold lvars now only updated on actual lvar changed received from server, not when you write to the offset
  - updated to MSFS SDK 0.20.5.0  

FSUIPC7 v7.3.15 released on 15th November 2022 contains the following changes:
  - rebuilt against MSFS SDK 0.20.4.0
  - the following additional controls have been added:
      ROTOR_LONGITUDINAL_TRIM_SET
	  ROTOR_LONGITUDINAL_TRIM_INC
	  ROTOR_LONGITUDINAL_TRIM_DEC
	  ROTOR_TRIM_RESET
	  AXIS_ROTOR_BRAKE_SET
	  ROTOR_BRAKE_ON
	  ROTOR_BRAKE_OFF
	  ROTOR_BRAKE_TOGGLE
	  MAC_CREADY_SETTING_DEC
	  MAC_CREADY_SETTING_INC
	  MAC_CREADY_SETTING_SET
	  PROP_LOCK_ON
	  PROP_LOCK_OFF
	  PROP_LOCK_SET
	  PROP_LOCK_TOGGLE
	  AXIS_COLLECTIVE_SET
	  COLLECTIVE_INCR
	  COLLECTIVE_DECR
	  TAIL_ROTOR_INCR
	  TAIL_ROTOR_DECR
	  ROTOR_GOV_SWITCH_OFF
	  ROTOR_GOV_SWITCH_ON
	  AUTO_HOVER_TOGGLE
	  AUTO_HOVER_OFF
	  AUTO_HOVER_SET
	  AUTO_HOVER_ON
	  PLASMA_ON
	  PLASMA_OFF
	  PLASMA_SET
	  PLASMA_TOGGLE
	  SPOILERS_INC
	  SPOILERS_DEC
	  RADIO_VOR3_IDENT_TOGGLE
	  RADIO_VOR3_IDENT_SET
	  RADIO_VOR3_IDENT_ENABLE
	  RADIO_VOR3_IDENT_DISABLE
	  RADIO_VOR4_IDENT_TOGGLE
	  RADIO_VOR4_IDENT_SET
	  RADIO_VOR4_IDENT_ENABLE
	  RADIO_VOR4_IDENT_DISABLE
	  ADF2_SET
	  ADF2_EXTENDED_SET
	  ADF2_LOWRANGE_SET
	  ADF2_HIGHRANGE_SET
	  ADF2_OUTSIDE_SOURCE
	  ADF2_NEEDLE_SET
	  ADF2_VOLUME_SET
	  ADF2_VOLUME_INC
	  ADF2_VOLUME_DEC
	  HELICOPTER_THROTTLE_INC
	  HELICOPTER_THROTTLE_DEC
	  AXIS_HELICOPTER_THROTTLE_SET
	  HELICOPTER_THROTTLE_SET
	  HELICOPTER_THROTTLE_CUT
	  HELICOPTER_THROTTLE_FULL
	  HELICOPTER_THROTTLE1_INC
	  HELICOPTER_THROTTLE1_DEC
	  AXIS_HELICOPTER_THROTTLE1_SET
	  HELICOPTER_THROTTLE1_SET
	  HELICOPTER_THROTTLE1_CUT
	  HELICOPTER_THROTTLE1_FULL
	  HELICOPTER_THROTTLE2_INC
	  HELICOPTER_THROTTLE2_DEC
	  AXIS_HELICOPTER_THROTTLE2_SET
	  HELICOPTER_THROTTLE2_SET
	  HELICOPTER_THROTTLE2_CUT
	  HELICOPTER_THROTTLE2_FULL
	  AXIS_CYCLIC_LATERAL_SET
	  AXIS_CYCLIC_LONGITUDINAL_SET
	  CYCLIC_LATERAL_LEFT
	  CYCLIC_LATERAL_RIGHT
	  CYCLIC_LONGITUDINAL_DOWN
	  CYCLIC_LONGITUDINAL_UP
	Note that the new axis AXIS_TAIL_ROTOR_SET is currently not recognised (and so has not been added)

FSUIPC7 v7.3.14 released on 1st November 2022 contains the following changes:
  - correction to assigning to lua files with an index >= 64. These were previously re-interpreted as assignments to presets.

FSUIPC7 v7.3.13 released on 28th October 2022 contains the following changes:
  - re-enabled ability to calibrate axis when assigned with 'Send to FS as normal axis' or when assigned outside of FSUIPC
  - Additional controls added: HEADING_BUG_SET_EX1, SET_THROTTLE_REVERSE_THRUST_ON, SET_THROTTLE_REVERSE_THRUST_OFF, DECISION_HEIGHT_SET, DECISION_ALTITUDE_MSL_SET
  - 'Rudder Trim Set Ex1' and 'Aileron Trim Set Ex1' flagged as axes controls
  - allow the following axes controls to go through FSUIPC's calibration facilities: *_EX1 axes controls for Throttle and PropPitch, Axis Steering Set

FSUIPC7 v7.3.12 released on 20th October 2022 contains the following changes:
  - WASM updated to 0.9.1: fixed bug that prevented lvars being set to a negative integer/short value, updated to VS2022
  - WAPI ipdated to 0.9.1: updated to VS2022 including toolkit update
  - fix for using custom control numbers
  - lua sound.play update: specifying a negative volume is no longer supported (it will be accepted but treated as a positive value)
  - switched to using new _EX1 function for facilities request

FSUIPC7 v7.3.11 released on 5th October 2022 contains the following changes:
  - corrected preset loading in certain situations and when WAPI not enabled in ini
  - added CAMERA STATE simvar to offset 0x026D (1-Byte) for read-only
  - threads, including WideServer, now no longer started until aircraft loaded and ready-to-fly for the first time
  - lua [Auto] scripts now started when FSUIPC7 started and MSFS already running with aircraft loaded

FSUIPC7 v7.3.10 released on 27th September 2022 contains the following changes:
  - presets now loaded before general assignments loaded, preventing preset assignments in general axes and button sections being lost.

FSUIPC7 v7.3.9 released on 26th September 2022 contains the following changes:
  - fixed CTD caused by Lvar/hvar config data being received in quick succession
  - List Lvars menu option will no longer perform a reload - a new menu option is provided for this: Reload & List Lvars
  - Create Mouse Macro button removed from key assignments dialog (mouse macros not available in FSUIPC7)
  - Loading of presets corrected: in current version, presets are not loaded unless there is a [WAPI] section in your FSUIPC7.ini containing  EnableWAPI=Yes
  - Improved logging of number of available lvars, hvars and presets
  - new option available to have FSUIPC7 main window open on start-up (Options -> Open on Start)
  - presets assigned to axes now saved using preset name rather than control number
  - WASM updated to 0.9.0: removed gauge event handler and switched to using custom events 
  - WAPI updated to 0.9.0
  - Recompiled against SU10 SDK 0.9.3.0
  - WASM update: delay lvar loading until camera in vurtual cockpit - with this change, you should be able to either completely remove
                 or, for complex aircraft, reduce the LvarScanDelay parameter (if you have manually set that in an FSUIPC_WASM.ini)
  - corrections to loading lvars when starting a new flight with the same aircraft
  - BRAKE LEFT/RIGHT POSITION simvar (held in offsets 0c0BC4 and 0x0BC6) ranged changed from 0-16384 to 0-32767 in accordance with MSFS documentation
  - corrections to the enabling/disabling if the WASM menu item
  - no axes are now calibrated UNLESS assign with 'Send direct to FSUIPC Calibration'. So, axes assigned with
    'Send to FS as normal axis' are no longer calibrated. Note that you can still scale (and reverse) such axes if needed
	using FSUIPC's axes scaling feature (see the Advanced User guide for details)

FSUIPC7 v7.3.8 released on 28th August 2022 contains the following changes:
  - PMDG offsets available (but note that the SDK has still not been published)
  - WAPI updated to prevent issues when using multiple WAPI clients
  - WideFS enabled status correctly remembered
  - Presets moved to a separate drop-down menu (in assignment dialogs) available on a separate check-box
  - New offset added: 0x0590 holding Indicated Altitude Calibrated as a 4-byte float (in feet)

FSUIPC7 v7.3.7 released on 30th June 2022 contains the following changes:
  - PMDG 737 offsets enabled - BUT not currently working!
  - new ini option added: TrapMSFSkeys
  - added auto-detection of windows 11 to automatically set DisableMSFSMonitor ini parameter to Enum 
  - default to enable WASM if installed
  - corrected move of profile specific [LvarOffsets.xxx] section to separtate ini file when using UseProfiles=Files

FSUIPC7 v7.3.6  released on 30th May 2022 contains the following changes:
  - WAPI version updated tp 0.5.10: fixed cause of crash when using multiple WASM clients

FSUIPC7 v7.3.5 released on 29th May 2022 contains the following changes:
  - corrected repeat key assignments (previously not repeating)
  - added two new ini parameters for adjusting key repeat rate: InitialKeyRepeatRate & SubsequentKeyRepeatRate
  - WASM and WAPI both updated to 0.5.9: changed to increase the maximum number of lvars available from 2044 to 3066
  - corrected shift-codes used when sending keys using FSUIPC-added controls
  - enabled the win key to be sent using FSUIPC-added controls (lwin is sent)
  - MobuFlight events file updated to version as of 28/05/2020

FSUIPC7 v7.3.4 released on 19th May 2022 contains the following changes:
  - WAPI updated to 0.5.8
  - bug fixed relating to bulk writing to offsets when one of the offsets not associated to a simvar
    (affected setting payloads when using ProSim)
  - bug fixed that prevented key assignments to presets functioning correctly
  - corrected use of left/right modifiers in ket assignments for shift and control key modifiers, added distinction
    between left/right alt key modifier, and removed windows key as modifier (as not possible to use)
  - changes to setting focus/foreground window when sending key presses

FSUIPC7 v7.3.3 released on 12th April 2022 contains the following changes:
  - WASM / WAPI updated (minor changes)
  - re-enabled main window to allow scrolling to view lvars/hvars
  - updated to MSFS SDK 0.18.0.0
  - new ini parameter added 'UseKeyboardHook'. When set, uses a global keyboard hook to receive key presses
    directly from windows and not via simconnect. To be used if using controllers that send keypresses that are otherwise not detected
	by FSUIPC7

FSUIPC7 v7.3.2 released on 20th March 2022 contains the following changes:
  - Keyboard input to FS enabled when FSUIPC has the focus
  - Updates made when running FSUIPC7 on an MSFS client machine to allow keys to be sent.

FSUIPC7 v7.3.1 released on 9th March 2022 contains the following changes:
  - bug fixed that prevented assignemnts to button numbers 64-95 from being triggered

FSUIPC7 v7.3.0 released on 6th March 2022 contains the following changes:
  - Updated to SDK 0.17.0.0. The following events have been added:
    New events:
	  TOGGLE_THROTTLE1_REVERSE_THRUST
	  TOGGLE_THROTTLE2_REVERSE_THRUST
	  TOGGLE_THROTTLE3_REVERSE_THRUST
	  TOGGLE_THROTTLE4_REVERSE_THRUST
	  SET_THROTTLE1_REVERSE_THRUST_ON
	  SET_THROTTLE2_REVERSE_THRUST_ON
	  SET_THROTTLE3_REVERSE_THRUST_ON
	  SET_THROTTLE4_REVERSE_THRUST_ON
	  SET_THROTTLE1_REVERSE_THRUST_OFF
	  SET_THROTTLE2_REVERSE_THRUST_OFF
	  SET_THROTTLE3_REVERSE_THRUST_OFF
	  SET_THROTTLE4_REVERSE_THRUST_OFF
	  THROTTLE1_REVERSE_THRUST_HOLD
	  THROTTLE2_REVERSE_THRUST_HOLD
	  THROTTLE3_REVERSE_THRUST_HOLD
	  THROTTLE4_REVERSE_THRUST_HOLD
	  MASTER_WARNING_SET
	  MASTER_WARNING_ON
	  MASTER_WARNING_OFF
	  MASTER_WARNING_TOGGLE
	  MASTER_WARNING_ACKNOWLEDGE
	  MASTER_CAUTION_SET
	  MASTER_CAUTION_ON
	  MASTER_CAUTION_OFF
	  MASTER_CAUTION_TOGGLE
	  MASTER_CAUTION_ACKNOWLEDGE
	  AP_ALT_RADIO_MODE_TOGGLE
	  AP_ALT_RADIO_MODE_SET
	  AP_ALT_RADIO_MODE_ON
	  AP_ALT_RADIO_MODE_OFF
	  MENU_RENO_KICK_PLAYER
	Existing events now recognised:
	  ELEVATOR_DOWN
	  ELEVATOR_UP
	  AILERON_LEFT
	  AILERON_RIGHT
	  TAXI_LIGHTS_ON
	  TAXI_LIGHTS_OFF
	  NAV_LIGHTS_ON
	  NAV_LIGHTS_OFF
	  STARTER1_SET
	  STARTER2_SET
	  STARTER3_SET
	  STARTER4_SET
  - Functionality to set lvars, activate hvars, call presets and execute calculator code added at offset 0x7C50
  - Functionality to add any simvar to an offset free for general use
  - When the WASM is enabled, the ipcReady.lua file is now only started once lvars/hvars are available
  - correction to starting lua autos when not using the FSUIPC WASM module
  - correction to updating/writing to the PUMP SWITCH offsets

FSUIPC7 v7.2.16 released on 14th February 2022 contains the following changes:
  - New functionality to assign to calculator code presets, loaded from files events.txt and myevents.txt
  - WASM updated to 0.5.7, to allow 1k of calculator code (was previously 256bytes)
  - maximum number of events loaded from event files now defined by new ini parameter MaxNumberOfCustomEvents
  - added implicit call to Reload the WASM before listing lvars
  - drop-down menu for testing lvars/hvars increased in width
  - new controls added:
    OIL_COOLING_FLAPS_SET
    OIL_COOLING_FLAPS_UP
    OIL_COOLING_FLAPS_DOWN
    OIL_COOLING_FLAPS_TOGGLE
    RADIATOR_COOLING_FLAPS_SET
    RADIATOR_COOLING_FLAPS_UP
    RADIATOR_COOLING_FLAPS_DOWN
    RADIATOR_COOLING_FLAPS_TOGGLE
    NAV1_VOLUME_SET_EX1
    NAV2_VOLUME_SET_EX1
    TACAN1_ACTIVE_CHANNEL_SET
    TACAN1_ACTIVE_MODE_SET
    TACAN1_STANDBY_CHANNEL_SET
    TACAN1_STANDBY_MODE_SET
    TACAN1_SWAP
    TACAN1_VOLUME_DEC
    TACAN1_VOLUME_INC
    TACAN1_VOLUME_SET
    TACAN2_ACTIVE_CHANNEL_SET
    TACAN2_ACTIVE_MODE_SET
    TACAN2_STANDBY_CHANNEL_SET
    TACAN2_STANDBY_MODE_SET
    TACAN2_SWAP
    TACAN2_VOLUME_DEC
    TACAN2_VOLUME_INC
    TACAN2_VOLUME_SET
    G_LIMITER_ON
    G_LIMITER_OFF
    G_LIMITER_SET
    G_LIMITER_TOGGLE
    TACAN1_SET
    TACAN2_SET
    TACAN1_OBI_DEC
    TACAN2_OBI_DEC
    TACAN1_OBI_INC
    TACAN2_OBI_INC
    TACAN1_OBI_FAST_DEC
    TACAN2_OBI_FAST_DEC
    TACAN1_OBI_FAST_INC
    TACAN2_OBI_FAST_INC
    TOGGLE_TACAN_DRIVES_NAV1
    CONDITION_LEVER_SET
    CONDITION_LEVER_INC
    CONDITION_LEVER_DEC
    CONDITION_LEVER_HIGH_IDLE
    CONDITION_LEVER_LOW_IDLE
    CONDITION_LEVER_CUT_OFF
    AXIS_CONDITION_LEVER_SET
    CONDITION_LEVER_1_SET
    CONDITION_LEVER_1_INC
    CONDITION_LEVER_1_DEC
    CONDITION_LEVER_1_HIGH_IDLE
    CONDITION_LEVER_1_LOW_IDLE
    CONDITION_LEVER_1_CUT_OFF
    AXIS_CONDITION_LEVER_1_SET
    CONDITION_LEVER_2_SET
    CONDITION_LEVER_2_INC
    CONDITION_LEVER_2_DEC
    CONDITION_LEVER_2_HIGH_IDLE
    CONDITION_LEVER_2_LOW_IDLE
    CONDITION_LEVER_2_CUT_OFF
    AXIS_CONDITION_LEVER_2_SET
    CONDITION_LEVER_3_SET
    CONDITION_LEVER_3_INC
    CONDITION_LEVER_3_DEC
    CONDITION_LEVER_3_LOW_IDLE
    CONDITION_LEVER_3_CUT_OFF
    AXIS_CONDITION_LEVER_3_SET
    CONDITION_LEVER_4_SET
    CONDITION_LEVER_4_INC
    CONDITION_LEVER_4_DEC
    CONDITION_LEVER_4_HIGH_IDLE
    CONDITION_LEVER_4_LOW_IDLE
    CONDITION_LEVER_4_CUT_OFF
    AXIS_CONDITION_LEVER_4_SET
  - new ini parameter added (default value Yes): StopWAPIInMenu

FSUIPC7 v7.2.15 released on 26th January 2022 contains the following changes:
  - Access to the following controls/events have been added:
		FLIGHT_LEVEL_CHANGE
		FLIGHT_LEVEL_CHANGE_ON
		FLIGHT_LEVEL_CHANGE_OFF
		RPM_SLOT_INDEX_SET
		BEACON_LIGHTS_ON
		BEACON_LIGHTS_OFF
		AP_SPD_VAR_SET_EX1
  - New lua functions for hvars added:
		 ipc.getHvarName(hvarId)
		 ipc.getHvarId(hvarName)
  - The following simulator variables have been added to offsets:
		0x0798: AUTOPILOT ALTITUDE LOCK VAR:3 [4 bytes]
		0x07A8: NEW FUEL SYSTEM [1 byte]
		0x07A9: NEW ELECTRICAL SYSTEM [1 byte]
		0x07AA: EXTERNAL_POWER_AVAILABLE [1 byte]
		0x07AB: EXTERNAL_POWER_ON [1 byte]
  - New ini parameter UseAirLocForProfiles, to allow matching on the air file folder name for profiles
  - WASM updated to 0.5.6:
		- new ini parameter added UseAirLocForHvars, to allow hvar file matching on air file folder name
		- logging messages for processing hvar files corrected and updated

FSUIPC7 v7.2.14 released on 21st December 2021 contains the following changes:
  - Corrected loctation of flight files for MS Store installations stored in offset 0x1000
  - Corrected use of LuaPath ini parameter when using a relative path
  - added new ini parameter for the [General] section: NumberOfPumps
    This restricts the request for the indexed simvars
	    FUELSYSTEM PUMP ACTIVE
		FUELSYSTEM PUMP SWITCH
	to the number of pumps defined by this ini parameter.
	This has been added as requesting these indexed simvars in aircraft that use the new FuelSystem module
	that have less than the number of pumps requested will produce continual errors in the MSFS developers console.
	The default value for this parameter is 6. If you do not use the developers console, you can set this to 16 to request all
	indices for these variables (regardless of aircraft).

FSUIPC7 v7.2.13 released on 19th November 2021 contains the following changes:
  - Rebuilt against MSFS SDK v0.16.0.0
  - The following indexed simvars have been added to offsets, all as 1 byte (boolean) values,
    the 'ACTIVE' ones being read-only and the 'SWITCH' ones read/write:
		0x0B02 FUELSYSTEM PUMP ACTIVE:1
		0x0B03 FUELSYSTEM PUMP SWITCH:1
		0x0B04 FUELSYSTEM PUMP ACTIVE:2
		0x0B05 FUELSYSTEM PUMP SWITCH:2
		0x0B06 FUELSYSTEM PUMP ACTIVE:3
		0x0B07 FUELSYSTEM PUMP SWITCH:3
		0x0B08 FUELSYSTEM PUMP ACTIVE:4
		0x0B09 FUELSYSTEM PUMP SWITCH:4
		0x0B0A FUELSYSTEM PUMP ACTIVE:5
		0x0B0B FUELSYSTEM PUMP SWITCH:5
		0x0B10 FUELSYSTEM PUMP ACTIVE:6
		0x0B11 FUELSYSTEM PUMP SWITCH:6
		0x0B12 FUELSYSTEM PUMP ACTIVE:7
		0x0B13 FUELSYSTEM PUMP SWITCH:7
		0x0B14 FUELSYSTEM PUMP ACTIVE:8
		0x0B15 FUELSYSTEM PUMP SWITCH:8
		0x0B16 FUELSYSTEM PUMP ACTIVE:9
		0x0B17 FUELSYSTEM PUMP SWITCH:9
		0x0AEE FUELSYSTEM PUMP ACTIVE:10
		0x0AEF FUELSYSTEM PUMP SWITCH:10
		0x0AA8 FUELSYSTEM PUMP ACTIVE:11
		0x0AA9 FUELSYSTEM PUMP SWITCH:11
		0x0AF2 FUELSYSTEM PUMP ACTIVE:12
		0x0AF3 FUELSYSTEM PUMP SWITCH:12
		0x0AF6 FUELSYSTEM PUMP ACTIVE:13
		0x0AF7 FUELSYSTEM PUMP SWITCH:13
		0x0AFA FUELSYSTEM PUMP ACTIVE:14
		0x0AFB FUELSYSTEM PUMP SWITCH:14
		0x0AFC FUELSYSTEM PUMP ACTIVE:15
		0x0AFD FUELSYSTEM PUMP SWITCH:15
		0x0AFE FUELSYSTEM PUMP ACTIVE:16
		0x0AFF FUELSYSTEM PUMP SWITCH:16
  - indexed simvar FUELSYSTEM ENGINE PRESSURE added to same offset as legacy simvar GENERAL ENG FUEL PRESSURE for 4 engines
  - ini a parameter DisableMSFSMonitor can now rake a value if Enum to allow MSFS window to be detected on some windows 11 systems
  - increased multi-threaded protection around lvar/hvar names access (could previously occasionally cause a CTD)
  - Disconnected WAPI interface when FSUIPC7 disconnects
  - new ini parameter KillLuasOnSimStop added
  - Experimental feature (currently undocumented) to allow FSUIPC7 to be ran on a client PC.
    I will post a topic on how to use this feature.

FSUIPC7 v7.2.12 released on 5th November 2021 contains the following changes:
  - WAPI updated to v0.5.5 (correction for when connection restarted in same session)
  - Added new ini parameter to help with issues with Windows 11 experienced by some users: DisableMSFSMonitor
  - code improvements to lua thread close down and crash handling
  - Following simvars added to offsets, all 8 byte floats:
		0x7C00 - EMPTY WEIGHT PITCH MOI
		0x7C08 - EMPTY WEIGHT ROLL MOI
		0x7C10 - EMPTY WEIGHT YAW MOI
		0x7C18 - EMPTY WEIGHT CROSS COUPLED MOI
		0x7C20 - TOTAL WEIGHT PITCH MOI
		0x7C28 - TOTAL WEIGHT ROLL MOI
		0x7C30 - TOTAL WEIGHT YAW MOI
		0x7C38 - TOTAL WEIGHT CROSS COUPLED MOI
  - Following simvars added to offsets
		0x07CE 2bytes - AUTOPILOT HEADING LOCK DIR:3
		0x07F8 2bytes - AUTOPILOT VERTICAL HOLD VAR:3
  - correction for some issues starting programs from the [Programs] ini section
  - Method to determine MS Store vs Steam install changed - no longer relying on MSFS registry entries
 
FSUIPC7 v7.2.11 released on 21st October 2021 contains the following changes:
  - WASM updated to 0.5.5: changed to recognise hvars (in *.hvar files) without the preceding 'H:'
  - distinguish between left/right shoft and control modifers when sending keypresses assigned to buttons (not for FSUIPC key assignments!)
  - added new simvar GPS OVERRIDDEN to offset 0C7D
  - made simvar GPS DRIVES NAV1 at offset 132C writeable
  - Updated to MSFS SDK 0.15.0.0

FSUIPC7 v7.2.10 released on 14th September 2021 contains the following changes:
  - WAPI updated to 0.5.4
  - prevent fault/exception being thrown on FSUIPC7 when MSFS exits

FSUIPC7 v7.2.9 released on 10th September 2021 contains the following changes:
  - fixed bug causing a CTD when using the UD size/type specifier in lvars-to-offsets
  - added simvar Local Day Of Week to offset 0x026C
  - fixed bug that cause some lua event.offset callbacks to be dropped
  - updated to MSFS SDK 0.14.1.0

FSUIPC7 v7.2.8 released on 27th August 2021 contains the following changes:
  - WASM updated to 0.5.4: lvar/hvar names restricted to MAX_VAR_NAME_SIZE characters (currently set to 56)
  - corrections to updating lvars via offsets, especially for F (float) types

FSUIPC7 v7.2.7 released on 23rd August 2021 contains the following changes:
  - Lights Potentiometer Set controls flagged as axis controls 
  - double quotes removed from ICAO model, type and designator offsets
  - WASM/WAPI updated to 0.5.3:
          - number of lvar CDAs increased to support up to 2044 lvars per aircraft
		  - correction to bug where wrong lvar value passed to lvar update callback when not in 1st CDA (id above 1023)

FSUIPC7 v7.2.6 released on 5th August 2021 contains the following changes:
  - correction to lvar/havr access introduced in last patch

FSUIPC7 v7.2.5 released on 3rd August 2021 contains the following changes:
  - Updated to MSFS SDK v0.14.0.0
  - Offset 0x3124 updated to contain 0 when not connected to MSFS, so can be used to determine connection status
  - WAPI I/F (providing access to lvars/hvars) not enabled if WASM not installed

FSUIPC7 v7.2.4 released on 28th July 2021 contains the following changes:
  - additional correction to run programs
  - enabled hot key to unminimise from task bar as well as open from system tray
  - new simvars added to offset 0x05D6, 1 bitwise-byte for
        IS GEAR FLOATS - bit 0
		IS GEAR SKIDS - bit 1
		IS GEAR SKIS - bit 2
		IS GEER WHEELS - bit 3

FSUIPC7 v7.2.3 released on 23rd July 2021 contains the following changes:
  - Correction to running programs from the ini [Programs] section when the program requires arguments
  - Key input events table updated to SDK 0.13.0.0
  - Correction in WASM module to allow luas to be restarted from Auto sections

FSUIPC7 v7.2.2 released on 13th July 2021 contains the following changes:
  - New lua function ipc.ReloadWASM() added
  - Flagged Anti Ice Gradual Set Eng controls as axes controls
  - Updated to clear lvar set CDA after being used so that the same command can be resent
  - Changed starting of autos (lua and macro) until after lvars have been loaded, when the WAPI has been enabled.
  - WASM / WAPI updated to 0.5.2
  - allow hvars to be loaded from WASM persistent storage area (i.e. under User' MSFS Package folder)
  - MobiFlight event files now optionally installed via installer (NOT installed for use!)
  - additional hvar files provided (NOT installed for use!)

FSUIPC7 v7.2.1 released on 22nd June 2021 contains the following changes:
  - fixed bug preventing lua plugins from being auto-started when FSUIPC7 started and MSFS in a pause state
  - additional simvars added to offsets: AUTOPILOT GLIDESLOPE ACTIVE, AUTOPILOT GLIDESLOPE ARM, SIMULATION TIME, BUS LOOKUP INDEX, BUS CONNECTION ON:6

FSUIPC7 v7.2.0 released on 8th June 2021 contains the following changes:
  - 'state' of AI traffic in trafic tables/offsets now populated correctly
  - removed logging of slope adjustments when no slope applied
  - Added new FSUIPC control: Trigger Auto-save. Used to manually trigger an 'auto-save'.
  - Added new facility to add lvars to offsets vi an LvarsToOffsets ini parameter section
  - WAPI/WASM updated to v0.5.1
  - AUTOPILOT VS SLOT INDEX simvar added to offset 0x02FC
  - Enabled write to offset 0x0818 AUTOPILOT ALTITUDE LOCK VAR:3. Write in feet, uses AP_ALT_VAR_SET_ENGLISH control
  - Updated to MSFS SDK 0.13.0 including adding additional events provided
  - Increased number of entries allowed under [AlsoManage] ini section from 32 to 64
  - Flagged LIGHT_POTENTIOMETER_SET as axis control

FSUIPC7 v7.1.0 released on 9th May 2021 contains the following changes:
  - Added simvars TURB ENG IGNITION SWITCH EX1:1/2/3/4 to offset area at 0x02C0/1/2/3.
  - Updated to recognise up to 128 buttons in Buttons Assignment panel
  - Added integration to the FSUIPC WASM module to provide lvar access as in FSUIPC5/6 (i.e. via macros and lua scripts)
  - additional lua functions added to read/write lvars as strings: readLvarSTR, writeLvarSTR
  - additional lua function added to activate hvars: activateHvar
  - WASM menu added to Add-ons menu when FSUIPC WASM detected
  - Read-only protection removed from offsets A000-A200 (so now available as free user offsets, as documented).

FSUIPC7 v7.0.9 released on 14th April 2021 contains the following changes:
  - rebuild against SDK 0.12.0.0 for MSFS 1.15.7.0

FSUIPC7 v7.0.8 released on 20th March 2021 contains the following changes:
  - fix for offset monitoring bug
  - fix to start axes scanning when FSUIPC7 started and MSFS already running + flight loaded

FSUIPC7 v7.0.7 released on 18th March 2021 contains the following changes:
  - update to starting/stopping [Auto] luas: now started when ready-to-fly
  - changes to default stall times
  - updates to killing luas to prevent problems when using the com library
  - correctuin to transponder offset 0x0354
  - correction to monitor functionality

FSUIPC7 v7.0.6 released on 10th March 2021 contains the following changes:
  - rebuilt against the latest MSFS SDK v0.11.0.0
  - changes to internal re-connection timers
  - Java SDK by Mouseviator updated to v1.1

FSUIPC7 v7.0.5 released on 17th February 2021 contains the following changes:
  - bug fixed that caused issues loading multiple *.evt files
  - New offsets added:
    0x0290 - AUTOPILOT ALTITUDE SLOT INDEX
    0x0294 - AUTOPILOT HEADING SLOT INDEX
    0x0298 - AUTOPILOT SPEED SLOT INDEX
    0x029D - APU SWITCH
  - increased allowable initial max stall time
  - built agaimst MSFS SDK 0.10.0.0

FSUIPC7 v7.0.4 released on 9th January 2021 contains the following changes:
  - fixed bug in key assignments to allow assignment to numpad keys with numlock off (PgDn, End, etc)
  - Correction to registry scanning that caused a crash when a non-existant device found
  - initial button delay now working, and improvements for a more accurate repeat rate (esp. with virtual buttons)
  - Further controls added from 0.9.0.0 SDK
  - lua event.cancel() function corrected to cancel all events on the argument function (previously only cancelled first found)
  - Further offsets added:
        0x0C10: GEAR CENTER STEER ANGLE
		0x0C46: AUTOBRAKES ACTIVE
		0c0C47 LIGHT BRAKE ON
  - added command-line option '-auto' that, when present, removes the 'Exit with FS' option and makes this mandatory
		(used when auto-starting FSUIPC7 from MSFS EXE.dll)
  - added new ini parameter AdjustNavForMagVar that adjusts the Nav1/2 in offsets 0x870 &7 0x0844 with magnetic variation
  - profile creation update to allow an empty axis profile to be created (i.e. when creating a new axis profile and not importing General axes)
  
FSUIPC7 v7.0.3 released on 24th December 2020 contains the following changes:
  - new *_EX1 controls added for throttle and prop pitch
  - console window position correction for -ve values
  - Autobrake offset added for A320Neo (0x0260)
  - reverted pushback direction select control (was reverted due to an SDK error that has now been corrected)
  - offset 0x0278 re-activated (Autocord Set)
  - Re-enabled offset 0x2F58 for write (Fuel Selected Transfer Mode)
  - Increased max parameter allowed for autobrake offset 0x2F80 to 6 (was 5)
  - arrow keys re-mapped for key input to allow assignment
  - added offsets for main control surface slopes (calibration) at offset 0x08A2
  - offsets for ALTITUDE and ATTITUDE FREEZE ON added at offsets 0x081C and 0x081D (although these are currently not populayed correctly for most, if not all, aircraft)
  
FSUIPC7 v7.0.2 released on 28th November 2020 contains the following changes:
  - Recompiled against MSFS SDK 0.8.0.0
  - Additional pause (sleep) control added
  - add-on controls now correctly annotated
  - allow DontLogThese ini parameter to be used in [Profile.xxx] sections (to be profile specific)
  - Allow MaxSteerSpeed to be set from user-defined offset. Also additional control added to set MaxSteerSpeed
  - List of axes controls updated
  - Alt key modifier re-activated, i.e. can now use as a modifier both when assigning keypresses and sending key presses to the sim
  - Added sim variable AUTOPILOT ALTITUDE LOCK VAR:3 at offset 0x0818
  - Correction to bug in loading macro files that only accessed L:vars (only 1st was recognised)
  
FSUIPC7 v7.0.1 released on 11th November 2020 contains the following changes:
  - Re-built against MSFS SDK 0.7.1.0
  - Fix for bug in Lua sound.play function
  - Improvemements to reconnection process when MSFS is restarted and FSUIPC7 left running
  - minor update to Delphi SDK

FSUIPC7 v7.0 released in November 2020:
  - Initial release
 
John Lawrence Dowson
14th February 2025